package matsubara.gear;

import java.awt.Color;
import java.awt.Graphics;
import matsubara.gear.EPlanetaryGear;

/**
 * <p>^Cg: </p>
 * <p>: </p>
 * <p>쌠: Copyright (c) 2002</p>
 * <p>Ж: </p>
 * @author 
 * @version 1.0
 */

public class PlanetaryGearW extends PlanetaryGear {
  Gear mx_piniGear2[];

  public PlanetaryGearW(int nX, int nY, int nSize, int nSunGear, int nPinionGear, int nRingGear, int nGearDepth, int nPinionGearNumber) throws EPlanetaryGear {
    super(nX, nY, nSize, nSunGear, nPinionGear, nRingGear, nGearDepth, nPinionGearNumber);
    double rPinionGearSize = (nRingGear - nSunGear) / 2 / 2;

    mx_piniGear2 = new Gear[nPinionGearNumber];

    //  sjIMA(O)
    for (int nIdx = 0; nIdx < mx_piniGear.length; nIdx++) {
      //  px␳
      mx_piniGear[nIdx].setAngle((2 * Math.PI) * nIdx / mx_piniGear.length
        + (2 * Math.PI) / mx_piniGear[nIdx].getGearCount() / 2
        - (2 * Math.PI) / mx_piniGear[nIdx].getGearCount() * (m_ringGear.getGearCount() % nPinionGearNumber) * nIdx / nPinionGearNumber
      );
    }

    //  sjIMA()
    for (int nIdx = 0; nIdx < mx_piniGear2.length; nIdx++) {
      mx_piniGear2[nIdx] = new Gear(0, 0, rPinionGearSize, nPinionGear, nGearDepth);
      mx_piniGear2[nIdx].setColor1(Color.orange);
      mx_piniGear2[nIdx].setColor2(Color.darkGray);
      //  px␳
      if (nPinionGear % 2 == 0) {
        mx_piniGear2[nIdx].setAngle((2 * Math.PI) * nIdx / mx_piniGear2.length
          - (2 * Math.PI) / mx_piniGear2[nIdx].getGearCount() * (m_ringGear.getGearCount() % nPinionGearNumber) * nIdx / nPinionGearNumber
        );
      }
      else {
        mx_piniGear2[nIdx].setAngle((2 * Math.PI) * nIdx / mx_piniGear2.length
          + (2 * Math.PI) / mx_piniGear2[nIdx].getGearCount() / 2
          - (2 * Math.PI) / mx_piniGear2[nIdx].getGearCount() * (m_ringGear.getGearCount() % nPinionGearNumber) * nIdx / nPinionGearNumber
        );
      }
    }

    move(0);  //  sjIMA𐳂ʒuɔzu邽

    if (nPinionGear % 2 == 0)
      m_sunGear.setAngle(2 * Math.PI / (m_sunGear.getGearCount() * 2));
  }


  /**
   * Ԃ̎Ȃǂɖ肪Ȃ`FbN
   * @param nSunGear TMÃTCY
   * @param nRingGear OMÃTCY
   * @param rPinionGearSize sjIMÃTCY
   * @param nPinionGearNumber sjIMǍ
   * @param nGearDepth t̐[
   * @param rPlanetaryCarrierSize vl^LÃTCY
   * @throws EPlanetaryGear p[^ɖ肪ꍇɗO𐶐
   */
  public void gearCheck(int nSunGear, int nRingGear, double rPinionGearSize, int nPinionGearNumber, int nGearDepth, double rPlanetaryCarrierSize) throws EPlanetaryGear {
    if ((nRingGear + nSunGear) % nPinionGearNumber != 0)
      throw new EPlanetaryGear("Ԃݍ܂B");
    if (nRingGear <= nSunGear)
      throw new EPlanetaryGear("OMA̓TMA傫Ȃ΂Ȃ܂B");
  }


  /**
   * vl^MA`
   * @param g `Ɏg Graphics IuWFNg
   */
  public void draw(Graphics g) {
    super.draw(g);
    for (int nIdx = 0; nIdx < mx_piniGear2.length; nIdx++) {
      mx_piniGear2[nIdx].draw(g);
    }
  }


  /**
   * ݒ肳ĂMAXs[hŎԂ]
   * d@]iGW]~iNMATCY{TMATCYj|[^[]~NMATCYjTMATCY
   * @param nMilliSec oߕb
   */
  public void move(double nMilliSec) {
    int nRingGearCount = m_ringGear.getGearCount();
    int nSunGearCount = m_sunGear.getGearCount();
//    double rPinionGearSize = (m_ringGear.getSize() - m_sunGear.getSize()) / 2;
    double rPlanetaryCarrierSize = (m_sunGear.getSize() + m_ringGear.getSize()) / 2;
    double rSunGearSpeed = getSunGearSpeed();
//    rSunGearSpeed = 0;

    m_sunGear.setAngle(m_sunGear.getAngle() + rSunGearSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);
    m_plaCarrier.setAngle(m_plaCarrier.getAngle() + m_rPlaCarrierSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);
    m_ringGear.setAngle(m_ringGear.getAngle() + m_rRingGearSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);

    //  sjIMA(O)
    double rPinionGearSpeed = m_rPlaCarrierSpeed + (m_rRingGearSpeed - m_rPlaCarrierSpeed) * m_ringGear.getGearCount() / mx_piniGear[0].getGearCount();
    for (int nIdx = 0; nIdx < mx_piniGear.length; nIdx++) {
      //  ʒu
      mx_piniGear[nIdx].setPosX(m_plaCarrier.rotateX(rPlanetaryCarrierSize + mx_piniGear[nIdx].getSize(), (2 * Math.PI) * nIdx / mx_piniGear.length));
      mx_piniGear[nIdx].setPosY(m_plaCarrier.rotateY(rPlanetaryCarrierSize + mx_piniGear[nIdx].getSize(), (2 * Math.PI) * nIdx / mx_piniGear.length));
      //  ]
      mx_piniGear[nIdx].setAngle( mx_piniGear[nIdx].getAngle()  + rPinionGearSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);
    }

    //  sjIMA()
    double rPinionGearSpeed2 = m_rPlaCarrierSpeed - (m_rRingGearSpeed - m_rPlaCarrierSpeed) * m_ringGear.getGearCount() / mx_piniGear[0].getGearCount();
    if (mx_piniGear2 != null) {
      for (int nIdx = 0; nIdx < mx_piniGear2.length; nIdx++) {
        //  ʒu
        mx_piniGear2[nIdx].setPosX(m_plaCarrier.rotateX(rPlanetaryCarrierSize - mx_piniGear2[nIdx].getSize(), (2 * Math.PI) * nIdx / mx_piniGear2.length));
        mx_piniGear2[nIdx].setPosY(m_plaCarrier.rotateY(rPlanetaryCarrierSize - mx_piniGear2[nIdx].getSize(), (2 * Math.PI) * nIdx / mx_piniGear2.length));
        //  ]
        mx_piniGear2[nIdx].setAngle(mx_piniGear2[nIdx].getAngle() + rPinionGearSpeed2 / 60 / 1000 * nMilliSec * 2 * Math.PI);
      }
    }
  }

  /**
   * vl^MÃTCYiajݒ
   * @param nSize a
   */
  public void setSize(double rSize) {
    super.setSize(rSize);
    for (int nIdx = 0; nIdx < mx_piniGear.length; nIdx++) {
      mx_piniGear[nIdx].setSize((m_ringGear.getSize() - m_sunGear.getSize()) / 2 / 2);
      mx_piniGear2[nIdx].setSize((m_ringGear.getSize() - m_sunGear.getSize()) / 2 / 2);
    }
    move(0);
  }

  /**
   * TMẢ]擾
   * @return TMẢ](rpm)
   */
  public double getSunGearSpeed() {
    double rRingGearCount = m_ringGear.getGearCount();
    double rSunGearCount = m_sunGear.getGearCount();

    return m_rPlaCarrierSpeed + (m_rRingGearSpeed - m_rPlaCarrierSpeed) * rRingGearCount / rSunGearCount;

//    return (m_rPlaCarrierSpeed * (rRingGearCount + rSunGearCount) - m_rRingGearSpeed * rRingGearCount) / rSunGearCount;
  }

  /**
   * TMẢ]ݒ
   * TMẢ]ɂ킹ăvl^LẢ]ω
   * @param rSunGearSpeed VTMẢ](rpm)
   */
  public void setSunGearSpeed(double rSunGearSpeed) {
    double rRingGearCount = m_ringGear.getGearCount();
    double rSunGearCount = m_sunGear.getGearCount();
    setPlaCarrierSpeed((int)(m_rRingGearSpeed * rRingGearCount - rSunGearSpeed * rSunGearCount) / (rRingGearCount - rSunGearCount));
  }


}